package service

import (
	"go/ast"
)

func handleTypeSpec(spec ast.Spec) string {
	s := spec.(*ast.TypeSpec)
	code := "class"
	code += " "
	code += s.Name.String()
	code += " "
	code += "{\n"
	code += handleClass(s.Type)
	// spew.Dump(s.TypeParams)
	code += "};\n"
	return code
}

func handleClass(e ast.Expr) string {
	code := ""
	code += "public:\n"
	code += handleExpr(e)
	// spew.Dump(e)
	return code
}

func handleStructType(s *ast.StructType) string {
	code := ""
	code += handleFieldList(s.Fields)
	return code
}

func handleFieldList(l *ast.FieldList) string {
	code := ""
	for _, f := range l.List {
		code += handleField(f)
	}
	return code
}

func handleField(f *ast.Field) string {
	code := ""
	code += "  "
	code += handleIdentExpr(f.Type)
	code += " "
	nado_zapyatuyu := false
	for _, n := range f.Names {
		if nado_zapyatuyu {
			code += ","
		}
		code += handleIdentExpr(n)
		nado_zapyatuyu = true
	}
	code += ";\n"
	return code
}
